'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reject = exports.resolve = exports.start = exports.RESOLVE_REJECTED = exports.RESOLVE_RESOLVED = exports.RESOLVE_START = exports.KEY = undefined;

var _reducer;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reducer2 = require('./utils/reducer');

var _reducer3 = _interopRequireDefault(_reducer2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var KEY = exports.KEY = '@@resolve';
var RESOLVE_START = exports.RESOLVE_START = KEY + '/start';
var RESOLVE_RESOLVED = exports.RESOLVE_RESOLVED = KEY + '/resolved';
var RESOLVE_REJECTED = exports.RESOLVE_REJECTED = KEY + '/rejected';

var start = exports.start = function start(key, promise) {
  return {
    type: RESOLVE_START,
    payload: { key: key, promise: promise }
  };
};

var resolve = exports.resolve = function resolve(key, result) {
  return {
    type: RESOLVE_RESOLVED,
    payload: { key: key, result: result }
  };
};

var reject = exports.reject = function reject(key, error) {
  return {
    type: RESOLVE_REJECTED,
    payload: { key: key, error: error }
  };
};

exports.default = (0, _reducer3.default)((_reducer = {}, _defineProperty(_reducer, RESOLVE_START, function (state, action) {
  var payload = action.payload;
  var key = payload.key;
  var promise = payload.promise;


  return _extends({}, state, _defineProperty({}, key, {
    resolving: true,
    resolved: false,
    rejected: false,
    promise: promise
  }));
}), _defineProperty(_reducer, RESOLVE_RESOLVED, function (state, action) {
  var payload = action.payload;
  var key = payload.key;
  var result = payload.result;


  return _extends({}, state, _defineProperty({}, key, {
    resolving: false,
    resolved: true,
    rejected: false,
    result: result
  }));
}), _defineProperty(_reducer, RESOLVE_REJECTED, function (state, action) {
  var payload = action.payload;
  var key = payload.key;
  var error = payload.error;


  return _extends({}, state, _defineProperty({}, key, {
    resolving: false,
    resolved: false,
    rejected: true,
    error: error
  }));
}), _reducer))({});