'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _flatten = require('./utils/flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (components) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  (0, _invariant2.default)(components, 'Expecting components array or single components. Got %s instead.', components);

  var pending = (0, _flatten2.default)(components).filter(function (component) {
    return component != null && typeof component.resolveOnServer === 'function';
  }).map(function (component) {
    return component.resolveOnServer.apply(component, args);
  });

  return Promise.all(pending);
};