'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _ducks = require('./ducks');

var _latest = require('./utils/latest');

var _latest2 = _interopRequireDefault(_latest);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var any = _react.PropTypes.any;
var bool = _react.PropTypes.bool;
var object = _react.PropTypes.object;
var func = _react.PropTypes.func;


var defaultMapStateToParams = function defaultMapStateToParams(state, ownProps) {
  return ownProps.params;
};
var defaultMapRouteToParams = function defaultMapRouteToParams(state, routeProps) {
  return routeProps.params;
};
var isObject = function isObject(test) {
  return test && (typeof test === 'undefined' ? 'undefined' : _typeof(test)) === 'object' && !Array.isArray(test);
};
var defaultOptions = {
  pure: true,
  hoistNonReactStatics: true,
  mergeOwnProps: true
};
var defaultSlice = function defaultSlice(state) {
  return state.resolver;
};
var extract = function extract(value) {
  if (value != null) {
    /* istanbul ignore else */
    if (value.resolving) {
      return value.promise;
    } else if (value.rejected) {
      return value.error;
    } else if (value.resolved) {
      return value.result;
    }
    // sanity check failed :)
    /* istanbul ignore next */
    (0, _invariant2.default)(false, 'Inconsistent state. Value should be either resolving, resolved, or rejected.');
  }

  return null;
};

var makeMapParamsToPromises = function makeMapParamsToPromises(hash) {
  var promiseThunks = Object.keys(hash).map(function (key) {
    var fn = hash[key];
    return function (acc, params) {
      return Object.assign(acc, _defineProperty({}, key, fn(params)));
    };
  });

  return function (params) {
    return promiseThunks.reduce(function (acc, thunk) {
      return thunk(acc, params);
    }, {});
  };
};

var propTypes = {
  /**
   * Params required to compose promises to resolve.
   * For example current instance id to fetch that comes from router params
   */
  resolveParams: any.isRequired,

  /**
   * Wheater all promises are resolved
   */
  resolved: bool.isRequired,

  /**
   * If any promise is still pending
   */
  pending: bool.isRequired,

  /**
   * If any promise were rejected
   */
  rejected: bool.isRequired,

  /**
   * Hash of promises result
   */
  result: object,

  /**
   * Redux store dispatch
   */
  dispatch: func.isRequired
};

var omitKnownProps = function omitKnownProps(props) {
  return Object.keys(props).reduce(function (acc, prop) {
    if (!(prop in propTypes)) {
      // eslint-disable-next-line no-param-reassign
      acc[prop] = props[prop];
    }

    return acc;
  }, {});
};

var makePropertyMerger = function makePropertyMerger(merge) {
  if (merge === false) {
    return function (result) {
      return result;
    };
  }
  if (merge === true) {
    return function (result, props) {
      return _extends({}, omitKnownProps(props), result);
    };
  }

  return merge;
};

exports.default = function (mapParamsToPromises) {
  var mapStateToParams = arguments.length <= 1 || arguments[1] === undefined ? defaultMapStateToParams : arguments[1];
  var mapRouteToParams = arguments.length <= 2 || arguments[2] === undefined ? defaultMapRouteToParams : arguments[2];
  var options = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

  (0, _invariant2.default)(isObject(mapParamsToPromises), 'Expecting mapParamsToPromises to be an object. Got %s instead.', mapParamsToPromises);

  (0, _invariant2.default)(mapParamsToPromises, 'Expecting mapParamsToPromises to be not null. Got %s instead', mapParamsToPromises);

  (0, _invariant2.default)(typeof mapStateToParams === 'function', 'Expecting mapStateToParams to be a function. Got %s instead', mapStateToParams);

  (0, _invariant2.default)(typeof mapRouteToParams === 'function', 'Expecting mapRouteToParams to be a function. Got %s instead', mapRouteToParams);

  (0, _invariant2.default)(isObject(options), 'Expecting options to be an object. Got %s instead.', options);

  (0, _invariant2.default)(['undefined', 'boolean', 'function'].indexOf(_typeof(options.mergeOwnProps)) > -1, 'Expecting options.mergeOwnProps to be either boolean or function. Got %s instead.', _typeof(options.mergeOwnProps));

  var finalOptions = _extends({}, defaultOptions, options);

  return function (Fulfilled, Rejected, Pending) {
    var keys = Object.keys(mapParamsToPromises);
    var finalMapParamsToPromises = makeMapParamsToPromises(mapParamsToPromises);
    var dispatchLatest = (0, _latest2.default)();
    var mapStateToProps = function mapStateToProps(state, ownProps) {
      var resolveParams = mapStateToParams(state, ownProps);
      var stateSlice = (ownProps.slice || defaultSlice)(state);

      (0, _invariant2.default)(stateSlice, 'Expecting state.resolver to be an object.\n       If you use different name please provide slice function\n       to map resolver state from global state object.');

      var is = function is(what) {
        return function (key) {
          return stateSlice[key] && stateSlice[key][what];
        };
      };

      var resolved = keys.every(is('resolved'));
      var rejected = keys.some(is('rejected'));
      var pending = !(resolved || rejected);

      // eslint-disable-next-line no-sequences, no-param-reassign, no-return-assign
      var result = keys.reduce(function (acc, key) {
        return acc[key] = extract(stateSlice[key]), acc;
      }, {});

      return {
        resolveParams: resolveParams,
        resolved: resolved,
        rejected: rejected,
        pending: pending,
        result: result
      };
    };

    var resolvePromises = function resolvePromises(params, dispatch) {
      var promises = finalMapParamsToPromises(params);

      dispatch = dispatchLatest(dispatch); // eslint-disable-line no-param-reassign

      var pending = Object.keys(promises).map(function (key) {
        var promise = promises[key];
        if (promise && typeof promise.then === 'function') {
          dispatch((0, _ducks.start)(key, promise));

          promise.then(function (result) {
            return dispatch((0, _ducks.resolve)(key, result));
          }, function (error) {
            return dispatch((0, _ducks.reject)(key, error));
          });
        } else {
          dispatch((0, _ducks.resolve)(key, promise));
        }

        return promise;
      });

      return Promise.all(pending);
    };

    var pure = finalOptions.pure;
    var hoistNonReactStatics = finalOptions.hoistNonReactStatics;
    var mergeOwnProps = finalOptions.mergeOwnProps;


    var impure = !pure;
    var mergeProperties = makePropertyMerger(mergeOwnProps);

    var Resolver = function (_Component) {
      _inherits(Resolver, _Component);

      function Resolver() {
        _classCallCheck(this, Resolver);

        return _possibleConstructorReturn(this, Object.getPrototypeOf(Resolver).apply(this, arguments));
      }

      _createClass(Resolver, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var _props = this.props;
          var pending = _props.pending;
          var resolveParams = _props.resolveParams;
          var dispatch = _props.dispatch;


          if (pending) {
            resolvePromises(resolveParams, dispatch);
          }
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var _props2 = this.props;
          var oldParams = _props2.resolveParams;
          var dispatch = _props2.dispatch;
          var nextParams = nextProps.resolveParams;

          if (!(0, _shallowequal2.default)(oldParams, nextParams)) {
            resolvePromises(nextParams, dispatch);
          }
        }
      }, {
        key: 'shouldComponentUpdate',
        value: function shouldComponentUpdate(nextProps) {
          return impure // always rerender
           || this.props.pending !== nextProps.pending // state changed
           || !(0, _shallowequal2.default)( // own properties changed (w/o result)
          mergeProperties({}, this.props), mergeProperties({}, nextProps));
        }
      }, {
        key: 'render',
        value: function render() {
          var _props3 = this.props;
          var resolved = _props3.resolved;
          var rejected = _props3.rejected;
          var pending = _props3.pending;
          var result = _props3.result;


          var props = mergeProperties(result, this.props);

          if (pending && Pending) {
            return _react2.default.createElement(Pending, null);
          } else if (rejected && Rejected) {
            return _react2.default.createElement(Rejected, props);
          } else if (resolved) {
            return _react2.default.createElement(Fulfilled, props);
          }

          return null;
        }
      }], [{
        key: 'resolveOnServer',
        value: function resolveOnServer(state, routeProps, dispatch) {
          (0, _invariant2.default)(typeof dispatch === 'function', 'Expecting dispatch to be a function. Got %s instead.', typeof dispatch === 'undefined' ? 'undefined' : _typeof(dispatch));

          var resolveParams = mapRouteToParams(state, routeProps);
          return resolvePromises(resolveParams, dispatch);
        }
      }]);

      return Resolver;
    }(_react.Component);

    Resolver.propTypes = propTypes;


    if (hoistNonReactStatics) {
      (0, _hoistNonReactStatics2.default)(Resolver, Fulfilled);
    }

    if (impure) {
      // say connect we have impure component inside
      return (0, _reactRedux.connect)(mapStateToProps, undefined, undefined, {
        pure: false
      })(Resolver);
    }

    return (0, _reactRedux.connect)(mapStateToProps)(Resolver);
  };
};