"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * Makes function wrapper that wraps a given function
 * and ensures only latest function will be called no matter
 * when it will be called.
 */

exports.default = function () {
  var frame = 0;
  return function (fn) {
    var snapshot = ++frame;

    return function () {
      if (snapshot === frame) {
        fn.apply(undefined, arguments);
      }
    };
  };
};